#ifndef __ALARM_H
#define __ALARM_H

#include "../lsapi/common.h"
#include "../lsapi/lswinbase.h"

using namespace std;

class CAlarmStorage;

/*********************
* mode:
* 0: everyday
* 1: weekly
* 2: monthly
* 3: yearly
* 4: once
**********************/

class CAlarm
{
public:
	CAlarm(CAlarmStorage* o, char* line);
	~CAlarm();
	void init(char* line);
	void exec(HWND hWnd);

	char		m_time[10];
	char		m_date[15];
	char		date_before[15];
	char		date_after[15];
	char		computed_date[3][15];
	int			mode;
	char		command[1024];
	char		args[1024];
	int			ktimer;
	// flags
	bool		is_enabled;
	int			group;
	bool		reminder;
	bool		reminder_time;

	static int id;
	int			my_id;

	CAlarm* next;
	CAlarmStorage* owner;

	bool testAlarm(LPSTR t);
	void initDate(char* tab, int r, int s);
	bool evalDate(char* g_date);
};

class CAlarmInt
{
public:
	CAlarmInt(char* line);
	~CAlarmInt();
	void init(char* line);
	void exec(HWND hWnd);

	int			timerid;
	char		command[1024];
	char		args[1024];
	int			intr;
	bool		is_enabled;
	int			group;

	static int id;
	int			my_id;

	CAlarmInt* next;

	bool testAlarm(LPSTR t);
};


class CAlarmStorage : public Window
{
public:
	CAlarmStorage(HWND parentWnd, int& code);
	~CAlarmStorage();

	void BangEnable(LPCTSTR args);
	void BangDisable(LPCTSTR args);
	void BangToggle(LPCTSTR args);
	void BangStat(LPCTSTR args);

	CAlarm				*alarms, *curAlarm;
	CAlarmInt			*alarmsInt, *curAlarmInt;
	bool					is_enabled;
	bool					USTime, YearWithSiecle;
	int						day, month, year, hour, min;
	int						reminderBefore;
	int						reminderAfter;
	int						reminderEveryMinute;
	char					m_time[10];
	char					m_date[10];

	void createAlarms();
	void destroyAlarms();
	void updateAlarms();
	bool updateTime(bool force);
	bool testDate(CAlarm* alarm);

  virtual void windowProc(Message& message);
  void onCreate(Message& message);
  void onDestroy(Message& message);
  void onTimer(Message& message);
  void onGetRevId(Message& message);
  void onRefresh(Message& message);
};

void BangEnableAlarm(HWND sender, LPCTSTR args);
void BangDisableAlarm(HWND sender, LPCTSTR args);
void BangToggleAlarm(HWND sender, LPCTSTR args);
void BangAlarmStat(HWND sender, LPCTSTR args);

extern "C" {
	__declspec( dllexport ) int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd);
	__declspec( dllexport ) int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath);
	__declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}


#endif /* __ALARM_H */
